--- chan_zap.c.orig	2006-02-11 02:43:23.000000000 +0530
+++ chan_zap.c.modified	2006-02-11 04:29:36.824474760 +0530
@@ -3929,7 +3929,7 @@
 				ast_log(LOG_WARNING, "Don't know how to handle ring/off hook for signalling %d\n", p->sig);
 			}
 			break;
-#ifdef ZT_EVENT_RINGBEGIN
+#if 1
 		case ZT_EVENT_RINGBEGIN:
 			switch(p->sig) {
 			case SIG_FXSLS:
@@ -6026,6 +6026,47 @@
 				return NULL;
 			}
 		} else if (p->use_callerid && p->cid_start == CID_START_RING) {
+			if (p->cid_signalling == CID_SIG_DTMF) {
+				int i = 0;
+				cs = NULL;
+				ast_log(LOG_DEBUG, "Receiving DTMF cid on "
+					"channel %s\n", chan->name);
+				zt_setlinear(p->subs[index].zfd, 0);
+				res = 2000;
+				for (;;) {
+					struct ast_frame *f;
+					res = ast_waitfor(chan, res);
+					if (res <= 0) {
+						ast_log(LOG_WARNING, "DTMFCID timed out waiting for ring. "
+							"Exiting simple switch\n");
+						ast_hangup(chan);
+						return NULL;
+					} 
+					f = ast_read(chan);
+					if (f->frametype == AST_FRAME_DTMF) {
+						dtmfbuf[i++] = f->subclass;
+						ast_log(LOG_DEBUG, "CID got digit '%c'\n", f->subclass);
+						res = 2000;
+					}
+					ast_frfree(f);
+						ast_log(LOG_DEBUG, "CID state %d, polarity %d, ringt %d(%d)\n", chan->_state, p->polarity,p->ringt, p->ringt_base);
+					if (p->ringt_base == p->ringt)
+						break;
+				}
+				dtmfbuf[i] = 0;
+				zt_setlinear(p->subs[index].zfd, p->subs[index].linear);
+				/* Got cid and ring. */
+				ast_log(LOG_DEBUG, "CID got string '%s'\n", dtmfbuf);
+				callerid_get_dtmf(dtmfbuf, dtmfcid, &flags);
+				ast_log(LOG_DEBUG, "CID is '%s', flags %d\n", 
+					dtmfcid, flags);
+				/* If first byte is NULL, we have no cid */
+				if (dtmfcid[0]) 
+					number = dtmfcid;
+				else
+					number = 0;
+			/* If set to use V23 Signalling, launch our FSK gubbins and listen for it */
+			} else {
 			/* FSK Bell202 callerID */
 			cs = callerid_new(cid_signalling);
 			if (cs) {
@@ -6138,6 +6179,7 @@
 				}
 			} else
 				ast_log(LOG_WARNING, "Unable to get caller ID space\n");
+			}
 		}
 		else
 			cs = NULL;
